<?php
	/*******************************************************************************
	* GENEALOGIE ASCENDANTE EN PHP
	* Administration de la base
	* Copyright (c) 2003-2005 Christian BACHELET
	*******************************************************************************/
	
   $root="../";
	$admin=$root."admin/";   
   $sys=$root."sys/";
   $cfg=$sys."cfg/";
   $pub=$root."pub/";
   include ($cfg."cfg.php");
   include ($pub."fonction.php");
   if (isset($lng) == 0) $lng=langue($HTTP_ACCEPT_LANGUAGE);
   include ($cfg.$lng.".php");
   include ($admin."sql.php");
   if (isset($fnc) == 0) $fnc=""; 	
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<html>

<!-- header de page -->
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
	<meta http-equiv="Pragma" content="no-cache">	   
	<title><?php echo "$sTitre - $sSousTitre" ?></title>
	<meta name="Classification" content=<?php echo"\"$sContenu\""?>>
	<meta name="Description" content=<?php echo "\"$sTitre\"" ?>>
	<meta name="Subject" content=<?php echo "\"$sTitre\"" ?>>
	<meta name="Keywords" content=<?php echo "\"$sClef\""?>>	
	<meta name="Author" lang=<?php echo "\"$lng\""?> content="Christian BACHELET">
	<meta name="language" content=<?php echo "\"$lng\""?>>
	<meta name="revisit-after" content="30 days">
	<meta name="robots" content="noindex,nofollow">
	<meta name="generator" content="Huile de coude">
   <link rel="stylesheet" href="../pub/arbre.css" type="text/css">
</head>

<body>

<!-- page -->
<hr size="4">

<table align="center" border="0" cellpadding="1" cellspacing="1">
   <tr><td align="center"><strong><?php echo "$sTitre"?></strong></td></tr>
   <tr><td align="center"><strong><?php echo "$sAdministration" ?></strong></td><tr>
</table>

<!-- affichage du menu -->
<hr size="4">

<table align="center" border="0" cellpadding="1" cellspacing="1">
   <tr>
   	<td>
	   	<?php echo 
				"<a href=\"../../\"><img src=\"../pub/maison.gif\" alt=\"$sAcceuil\" border=\"0\" width=\"20\" height=\"18\"></a> &nbsp;
	         <a href=\"index.php?lng=$lng&fnc=init\"> $sInitialisation</a> -
	         <a href=\"index.php?lng=$lng&fnc=inject\"> $sInjection</a>         
				<a href=\"index.php?lng=fr&fnc=$fnc\"><img src=\"../pub/fr.gif\" alt=\"En franais\" border=\"0\" width=\"24\" height=\"18\"></a>
				<a href=\"index.php?lng=en&fnc=$fnc\"><img src=\"../pub/en.gif\" alt=\"In english\" border=\"0\" width=\"24\" height=\"18\"></a>
				<a href=\"index.php?lng=es&fnc=$fnc\"><img src=\"../pub/es.gif\" alt=\"En espaol\" border=\"0\" width=\"24\" height=\"18\"></a>"
	      ?>
      </td>
   </tr>
</table>

<br>

<?php
	switch ($fnc)
		{
		case "init":
			//connection
			mysql_connect($sHost,$sUser,$sPass);
			
			if (sql_base($sBase)==false)
				{
				//cration de la base de donnes
				sql_creer_base($sBase,true);
				}
			
			//slection de la base de donnes
			mysql_selectdb($sBase);

			$table=$sTbIndividus;
			
			if (sql_table($sBase,$table)==false)
				{
				//cration de la table des individus
				$champs="sosa int(10) UNSIGNED NOT NULL,prenom varchar(32),nom varchar(32),datenaissance date,";
				$champs=$champs . "lieunaissance varchar(32),datedeces date,lieudeces varchar(32),profession varchar(32), photo varchar(16)";				
				$res=sql_creer_table($table,$champs,true);
				
				//cration de l'index sur la table des individus
				$res=sql_creer_index($table,"UNIQUE","sosa","sosa",true);
				}
				
			$table=$sTbUnions;
			
			if (sql_table($sBase,$table)==false)
				{
				//cration de la table des unions
				$champs="sosa1 int(10) UNSIGNED NOT NULL,sosa2 int(10) UNSIGNED NOT NULL,dateunion date,lieuunion varchar(32)";
				$res=sql_creer_table($table,$champs,true);
				
				//cration de l'index sur la table des unions
				$res=sql_creer_index($table,"UNIQUE","couple", "sosa1,sosa2",true);
				}

			$table=$sTbImplexes;
			
			if (sql_table($sBase,$table)==false)
				{
				//cration de la table des implexes
				$champs="sosa1 int(10) UNSIGNED NOT NULL,sosa2 int(10) UNSIGNED NOT NULL";
				$res=sql_creer_table($table,$champs,true);

				//cration de l'index sur la table des implexes
				$res=sql_creer_index($table,"UNIQUE","sosa", "sosa1,sosa2",true);
				}

			$table=$sTbEquivalences;
			
			if (sql_table($sBase,$table)==false)
				{
				//cration de la table des quivalences
				$champs="sosa1 int(10) UNSIGNED NOT NULL,sosa2 int(10) UNSIGNED NOT NULL";
				$res=sql_creer_table($table,$champs,true);

				//cration de l'index sur la table des quivalences
				//$res=sql_creer_index($table,"UNIQUE","sosa1","sosa1",true);
				$res=sql_creer_index($table,"UNIQUE","sosa","sosa1,sosa2",true);
				}
				
			$table=$sTbEclair;
			
			if (sql_table($sBase,$table)==false)
				{
				//cration de la table eclair
				$champs="nom varchar(32),lieu varchar(32),naissances int(4),unions int(4),deces int(4),debut int(4),fin int(4)";
				$res=sql_creer_table($table,$champs,true);

				//cration de l'index sur la table eclair
				$res=sql_creer_index($table,"UNIQUE","stat","nom,lieu",true);
				}
				
			break;
			
		case "inject":
			//connection
			mysql_connect($sHost,$sUser,$sPass);
			mysql_selectdb($sBase);

			$table=$sTbIndividus;
			
			if (sql_table($sBase,$table)==true)
				{
				//injection des donnes dans la table des individus
				$res=sql_remplir_table($table,$admin,"individus.txt",true);
				}
			else echo "$sTexte25 $table $sTexte26 <br><br>";

			$table=$sTbUnions;
			
			if (sql_table($sBase,$table)==true)
				{
				//injection des donnes dans la table des unions
				$res=sql_remplir_table($table,$admin,"unions.txt",true);
				}
			else echo "$sTexte25 $table $sTexte26 <br><br>";

			$table=$sTbImplexes;
			
			if (sql_table($sBase,$table)==true)
				{
				//injection des donnes dans la table des implexes
				$res=sql_remplir_table($table,$admin,"implexes.txt",true);
				}
			else echo "$sTexte25 $table $sTexte26 <br><br>";
			
			//calcul de la liste eclair
			echo "$sTexte28<br><br>";
			calcul_liste_eclair();
			
			//calcul des quivalences
			echo "$sTexte27<br><br>";
			calcul_equivalences();
			break;
		}
?>


