<?php
/*******************************************************************************
* GENEALOGIE ASCENDANTE EN PHP
* Fonctions d'administration
* Copyright (c) 2003-2005 Christian BACHELET
*******************************************************************************/

$sosa_maximum=0;
$tab_equivalences[0]=0;

/***********************************************************
* Vrifier l'existence d'une base de donnes
***********************************************************/
function sql_base($base)
	{
	$resultat=mysql_list_dbs();
	$nb=mysql_num_rows($resultat);
	for ($i=0;$i<$nb;$i++) if (mysql_db_name($resultat,$i)==$base) return(true);			
	return(false);
	}

/************************************************************
* Crer une base de donnes
*************************************************************/
function sql_creer_base($base,$message=false)
	{
 	global $sTexte29;
 	global $sTexte30;
	global $sTexte34;
		
	$resultat=mysql_query("CREATE DATABASE $base");
	
	if ($message==true)
		{
		echo "$sTexte34 $table : ";
		echo ($resultat==true) ? $sTexte30 : $sTexte29;
		echo "<br><br>";
		}
	
	return($resultat);
	}

/************************************************************
* Vrifier l'existence d'une table dans une base de donnes
*************************************************************/
function sql_table($base,$table)
	{
	$tables=mysql_list_tables($base);	
	while ($res=mysql_fetch_array($tables)) if ($res[0]==$table) return(true);	
	return(false);
	}

/**********************************************************
* Crer une table dans une base de donnes
**********************************************************/
function sql_creer_table($table,$champs,$message=false) 
 	{
 	global $sTexte17;
 	global $sTexte29;
 	global $sTexte30;
 	
	$requete="CREATE TABLE $table ($champs)";
	$resultat=mysql_query($requete);
	
	if ($message==true)
		{
		echo "$sTexte17 $table : ";
		echo ($resultat==true) ? $sTexte30 : $sTexte29;
		echo "<br><br>";
		}
	
	return($resultat);
	}

/**********************************************************
* Crer un index sur une table de donnes
**********************************************************/
function sql_creer_index($table,$type,$nom,$champs,$message=false)
	{
	global $sTexte19;
 	global $sTexte29;
 	global $sTexte30;
	
	$requete="ALTER TABLE $table ADD $type $nom ($champs)";
	$resultat=mysql_query($requete);
	
	if ($message==true)
		{
		echo "$sTexte19 $table : ";
		echo ($resultat==true) ? $sTexte30 : $sTexte29;
		echo "<br><br>";
		}

	return($resultat);	 
	}

/*********************************************************
* Vider les donnes d'une table
*********************************************************/
function sql_vider_table($table,$message=false) 
	{
	global $sTexte18;
	
	$requete="DELETE FROM $table";
	$resultat=mysql_query($requete);
	
	if ($message==true)
		{
		echo "$sTexte18 $table .";
		echo ($res==true) ? "OK" : "KO";
		echo "<br>";
		}
		
	return($resultat ? true : false);
	}

/**********************************************************
* Remplir une table  partir d'un fichier de donnes
**********************************************************/
function sql_remplir_table($table,$chemin,$fichier,$vider=false) 
	{
	global $sTexte20;
	global $sTexte21;
	global $sTexte22;
	global $sTexte23;
	global $sTexte24;
	
	$nbDonnees=0;
	$noLigne=0;
	$nbErreurs=0;

	if (file_exists($chemin.$fichier)) 
		{
		if ($vider==true) sql_vider_table($table);
		$fp=fopen($chemin.$fichier,"r");		
	
		while (!feof($fp)) 
			{
			$ligne=fgets($fp, 1024);
		
			if (strlen($ligne)>1)
				{
				$noLigne++;
				$liste=explode(";",$ligne);
				$nb=count($liste);

				if ($nb>1)
					{
					// ligne de commentaires
					$valeur=$liste[0];
										
					if (substr($valeur,0,1)!='#')
						{
						$requete = "INSERT INTO $table VALUES(";
			
						for ($i=0;$i<($nb-1);$i++) 
							{
							if ($i>0) $requete.=",";
							$valeur=$liste[$i];
							$requete.="\"$valeur\"";
							}
							
						$requete.=")";
						$resultat=mysql_query($requete);

						if ($resultat==false)
							{
							$nbErreurs++;
							echo "$sTexte21 $noLigne : \"$ligne\" - $nb valeur(s)<br>";
							}
						else $nbDonnees++;					
						}
					}
				}
			}
		
		fclose($fp);
		if ($nbErreurs) echo "### $nbErreurs $sTexte22 \"$fichier\" ### .<br><br>";
		echo "$sTexte20 $table : $nbDonnees $sTexte23 .<br><br>";
		}
	else echo "$sTexte24 \"$fichier\" .";
		 	
	return($nbErreurs);
	}

/*****************************************
* Calculer les quivalences de sosa
*****************************************/
function ancetres_equivalents($sosa_principal,$sosa_equivalent)
	{
	global $sosa_maximum;
	global $tab_equivalences;
	
	if ($sosa_equivalent<=$sosa_maximum)
		{		
		if ($tab_equivalences[$sosa_equivalent]) 
			{
			//enregistrer l'quivalence
			$tab_equivalences[$sosa_principal]=$sosa_equivalent;
			if ($sosa_maximum<$sosa_principal) $sosa_maximum=$sosa_principal;
		
			//quivalence du pre
			$sosa1=$sosa_principal*2;
			$sosa2=$sosa_equivalent*2;
			ancetres_equivalents($sosa1,$sosa2);
		
			//quivalence de la mre
			ancetres_equivalents($sosa1+1,$sosa2+1);		
			}
		}
	}
	
function calcul_equivalences()
	{		
	global $sosa_maximum;
	global $tab_equivalences;
	global $sTbEquivalences, $sTbIndividus, $sTbImplexes;

   //Raz liste
   sql_vider_table($sTbEquivalences);

	//recherche du plus grand numro sosa
	$requete=mysql_query("select max(sosa) as maximum from $sTbIndividus");
   $resultat=mysql_fetch_object($requete);
   $sosa_maximum=$resultat->maximum;
   
   //initialisation du tableau d'quivalences (sosa directs)
   for ($i=1;$i<=$sosa_maximum;$i++) $tab_equivalences[$i]=0;
   $requete=mysql_query("select sosa from $sTbIndividus");
   while ($resultat=mysql_fetch_object($requete)) $tab_equivalences[$resultat->sosa]=$resultat->sosa;   
   	
   //recherche et traitement des implexes
   $requete=mysql_query("select * from $sTbImplexes");
   while ($implexe=mysql_fetch_object($requete)) ancetres_equivalents($implexe->sosa1,$implexe->sosa2);		
			
	//remplissage de la table des quivalences
	for ($i=1;$i<=$sosa_maximum;$i++)
		if ($tab_equivalences[$i]!=0) 
			$requete=mysql_query("insert into $sTbEquivalences values(\"$i\",\"$tab_equivalences[$i]\")");
	}
	
/***********************************************************
* insrer ou mettre  jour une ligne dans la table clair
************************************************************/
function ligne_eclair($nom,$lieu,$date,$naissances,$unions,$deces)
   {
   global $sTbEclair;
   
   if ($nom<>"" and $date<>"" and $date<>"0000-00-00" and $lieu<>"")
      {
      //recherche d'une ligne de mme nom et mme lieu
      $annee=year($date);
      $requete=mysql_query("select * from $sTbEclair where nom=\"$nom\" and lieu=\"$lieu\"");
      $resultat=mysql_fetch_object($requete);

      if ($resultat)
         {
         //mise  jour de la ligne
         $naissances+=$resultat->naissances;
         $unions+=$resultat->unions;
         $deces+=$resultat->deces;

         $debut=$resultat->debut;
         if ($annee<$debut) $debut=$annee;
         $fin=$resultat->fin;
         if ($annee>$fin) $fin=$annee;
         //echo "update $nom $lieu $naissances $unions $deces $debut - $fin<br>";
         $requete=mysql_query("update $sTbEclair set naissances=$naissances, unions=$unions, deces=$deces, debut=$debut, fin=$fin where nom=\"$nom\" and lieu=\"$lieu\"");
         }
      else
         {
         //insertion d'une ligne
         $debut=$annee;
         $fin=$annee;
         //echo "insert $nom $lieu $naissances $unions $deces $debut - $fin<br>";
         $requete=mysql_query("insert into $sTbEclair values(\"$nom\",\"$lieu\",$naissances,$unions,$deces,$debut,$fin)");
         }
      }
   }

/*****************************************
* calculer la liste clair
*****************************************/
function calcul_liste_eclair()
   {
   global $sTbEclair, $sTbIndividus, $sTbUnions;
   
   //Raz liste
   sql_vider_table($sTbEclair);

   //traitement des individus
   $requete=mysql_query("select * from $sTbIndividus order by sosa");

   while ($fiche=mysql_fetch_object($requete))
      {
      //naissance
      ligne_eclair($fiche->nom,$fiche->lieunaissance,$fiche->datenaissance,1,0,0);

      //dcs
      ligne_eclair($fiche->nom,$fiche->lieudeces,$fiche->datedeces,0,0,1);
      }

   //traitement des unions
   $requete=mysql_query("select * from $sTbUnions order by sosa1,sosa2");

   while ($fiche=mysql_fetch_object($requete))
      {
      //homme
      $homme=chercher_individu($fiche->sosa1);
      ligne_eclair($homme->nom,$fiche->lieuunion,$fiche->dateunion,0,1,0);

      //femme
      $femme=chercher_individu($fiche->sosa2);
      ligne_eclair($femme->nom,$fiche->lieuunion,$fiche->dateunion,0,1,0);
      }
   }	
?>