<?php
	/*******************************************************************************
	* GENEALOGIE ASCENDANTE EN PHP
	* Construction de l'arbre d'ascendance
	* Copyright (c) 2004-2005 Christian BACHELET
	*******************************************************************************/
	
   $root="../";
   $sys=$root."sys/";
   $cfg=$sys."cfg/";
   $photo=$sys."photos/";
   $pub=$root."pub/";
   include ($cfg."cfg.php");
   include ($pub."fonction.php");
   if (isset($lng) == 0) $lng=langue($HTTP_ACCEPT_LANGUAGE);
   include ($cfg.$lng.".php");
   $page="arbre";
   $sSousTitre=$sArbre;
 	
 	if (isset($pm) == 0) $pm=""; 	
 	$Tab=explode(".",$pm);
	if (count($Tab) > 0) $SosaCourant=$pm;
	if (count($Tab) > 1) {$SosaCourant=$Tab[0]; $ng=$Tab[1];}
	if ($SosaCourant == "" || $SosaCourant < 1) $SosaCourant=1;		

 	if (isset($ng) == 0) $ng=4;	
	if ($ng == "") $ng=4;
	if ($ng > 8) $ng=8;
	if ($ng < 1) $ng=1;   
   $url=$pub."arbre.php";
   $param="&pm=$SosaCourant.$ng";   
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<html>

<!-- header de page -->
<?php include ($pub."header.php") ?>

<body>

<!-- affichage du menu -->
<?php include ($pub."menu.php") ?>

<!-- affichage des options -->
<table align="center" border="0" cellpadding="3" cellspacing="0">
   <tr><td><?php echo "$sTexte9 $sTexte10" ?></td></tr>
</table>

<br>

<?php
// connection
mysql_connect($sHost,$sUser,$sPass);
mysql_selectdb($sBase);
?>

<?php
/***************************************
* Calculer la position dans le tableau
***************************************/	
function calculer_position($t,$l,$nc,$s)
	{
	$ret=0;
	$nb=0;
	
	$pere=pere($s);
	$mere=mere($s);
	
	$l--;
	
	if ($l>0)
		{
		for ($c=1;$c<=$nc && $nb<2;$c++)
			{
			$v = $t[$l][$c];
			
			if ($v==$pere or $v==$mere)
				{
				$ret+=$c;
				$nb++;
				}
				
			if ($v>$mere) $c=$nc;
			}
			
		if ($nb>1) $ret= intval($ret/$nb);
		}
				
	return($ret);
	}

/******************************************
* Dcale les positions dans le tableau
******************************************/
function decaler_position(&$t,$nl,$nc,$s,$p)
	{
	$ret=0;
	$d=0;

	$nl--;
	
	if ($nl>0)
		{
		// calcul du dcalage  appliquer
		for ($c=$p-4;$c<=($p+2);$c++)
			{
			if ($c > 0)
				{
				$v1=$t[$nl][$c];
				$v2=$t[$nl][$c+8];
									
				if ($v1>0)
					{
					$pere=pere($s);
					$beaupere=pere($s+1);
					$bellemere=mere($s+1);
				
					$d=$p+4-$c;
					if ($v1<$pere) $d=4;
					if (($s%2)==0 && (($v1==$beaupere && $v2!=$bellemere) || $v1==$bellemere)) $d+=4;				
					if ($v1<$pere && $v2==0) $d=0;
				
					if ($v2==$beaupere)
						{
						if (sosa_equivalent($bellemere)) $d=0;
						}

					//echo "Sosa: $s ($v1 - $v2) Position: $p Colonne: $c Dcalage: $d <br>";
					}
				}
			}
		
		// dcalage effectif
		if ($d>0)
			{			
			$limite=$s*pow(2,$nl);

			for ($l=1;$l<=$nl;$l++)
				{
				// on dcale seulement les sosa de numro suprieurs  l'anctre de l'individu
				$p=$nc+$d;
				
				//echo "Sosa: $s - Ligne: $l / $nl - Limite: $limite - Dcalage: $d <br>";				
				
				for ($c=$nc;$c>0;$c--,$p--)
					{
					$v=$t[$l][$c];

					if ($v)
						{					
						if ($v>$limite)
							{
							//echo "Sosa: $s - Ligne: $l / $nl - Dcalage: $v de $c vers $p <br>";
							$t[$l][$p]=$v;
							$t[$l][$c]=0;
							}
						else $c=0;
						}
					}
					
				$limite/=2;					
				}
			}
		}
	}
	
/*******************************
* Dessiner un trait
********************************/
function dessiner_trait(&$nb,$img,$alt)
	{
	global $epaisseur;
   global $w1;

	if ($nb!=0)
		{
		$w=$nb*$w1;
		echo "<td colspan=$nb width=$w>";
		echo "<img src=\"$img\" alt=\"$alt\" border=\"0\" width=\"$w\" height=\"$epaisseur\">";
		echo "</td>";
	   echo chr(13);
		echo chr(10);
		$nb=0;
		}
	}
?>
	
<?php
/****************************
 ng : nombre de gnrations
 nl : nombre de lignes
 nc : nombre de colonnes
 lg : ligne en cours
 cl : colonne en cours
****************************/
$color="black";
$nc=pow(2,$ng-1)*8-2;
$nl=$ng;

$epaisseur=2;

$w1=$sTailleBloc;
$w2=2*$w1;
$w6=6*$w1;
$w8=8*$w1;

// initialisation du tableau des ascendants
for ($lg=1;$lg<=$nl;$lg++)
	{
	for ($cl=1;$cl<=$nc;$cl++)
		{
		$tb[$lg][$cl]=0;
		}
	}

$niv=$nl-1;

// calcul du tableau des ascendants
for ($lg=1;$lg<=$nl;$lg++)
	{
	$pos=1;
	$sosa1=$SosaCourant*pow(2,$niv);
	$sosa2=($SosaCourant+1)*pow(2,$niv);

	for ($ns=$sosa1;$ns<$sosa2;$ns++)
		{
		if (sosa_equivalent($ns))
			{
			$res=calculer_position($tb,$lg,$nc,$ns);

			if ($res==0) decaler_position($tb,$lg,$nc,$ns,$pos);
			else $pos=$res;

			$tb[$lg][$pos]=$ns;
			$pos=$pos+8;
			}
		}

	$niv=$niv-1;
	}
?>

<?php
// recalcul des limites du tableau des ascendants
$pos=0;
$ld=1;

for ($l=1;$l<=$nl;$l++)
	{
	if ($pos==0) $ld=$l;
	
	for ($c=$nc;$c>0;$c--)
		{
		if ($tb[$l][$c])
			{
			if ($pos<($c+5)) $pos=$c+5;
			$c=0;
			}
		}
	}
	
$nc=$pos;	
?>

<!-- affichage du nombre de gnrations -->
<table align="center" border="0">
<?php
	echo "<tr>";
	echo chr(13);
	echo chr(10);		   	
	echo "<td>";
	
	if ($ng > 1)
		{
		$n=$ng-1;
		if ($n<1) $n=1;
		echo "<a href=\"$url2?lng=$lng&pm=$SosaCourant.$n\">";
		echo "<img src=\"prevoff.gif\" alt=\"-\" border=\"0\" width=\"16\" height=\"32\"></a>";
		}
	else echo "<img src=\"prevoff.gif\" alt=\"-\" border=\"0\" width=\"16\" height=\"32\">";
	
	echo "</td>";
	echo chr(13);
	echo chr(10);		   
	
	echo "<td align=\"center\">";
	echo "$ng $sTexte11";
	echo "</td>";
	echo chr(13);
	echo chr(10);		   
	
	echo "<td>";
	
	if ($ld==1 && $ng<10)
		{
		$n=$ng+1;
		echo "<a href=\"$url2?lng=$lng&pm=$SosaCourant.$n\">";
		echo "<img src=\"nextoff.gif\" alt=\"+\" border=\"0\" width=\"16\" height=\"32\"></a>";
		}
	else echo "<img src=\"nextoff.gif\" alt=\"+\" border=\"0\" width=\"16\" height=\"32\">";
	
	echo "</td>";
	echo chr(13);
	echo chr(10);
	
	echo "</tr>";
	echo chr(13);
	echo chr(10);
	
	// Descente de l'arbre
	if ($SosaCourant>1)
		{
		$SosaEnfant=enfant($SosaCourant);
		echo "<tr><td colspan=\"3\">";
		echo "<a href=\"$url2?lng=$lng&pm=$SosaEnfant.$ng\">$sTexte12</a>";
		echo "</td></tr>";
		echo chr(13);
		echo chr(10);	
		}
?>
</table>

<br>

<!-- affichage de l'arbre -->
<table align="center" border="0" cellpadding="0" cellspacing="0">

<?php
	// ligne vide de cadrage
	echo "<!-- Cadrillage de $nc cellule(s) -->";
   echo chr(13);
   echo chr(10);

	echo "<tr>";
   echo chr(13);
   echo chr(10);
   
   for ($cl=1;$cl<=$nc;$cl++)
   	{
		echo "<td width=$w1>";
		echo "<img src=\"pixel.gif\" border=\"0\" width=\"$w1\" height=\"2\">";
 		echo "</td>";
	   echo chr(13);
	   echo chr(10);
   	}

	echo "</tr>";
   echo chr(13);
   echo chr(13);
   echo chr(10);

	// boucle sur les gnrations
	for ($lg=$ld;$lg<=$nl;$lg++)
		{
	   $esp=0;  

		$gen=$nl-$lg;
		$sosa1=$SosaCourant*pow(2,$gen);
		$sosa2=($SosaCourant+1)*pow(2,$gen)-1;
		$gen++;

		echo "<!-- Gnration: $gen - Sosa de $sosa1  $sosa2 -->";
	   echo chr(13);
	   echo chr(10);
		
		echo "<tr>";
	   echo chr(13);
	   echo chr(10);

		// ligne d'ascendants
		for ($cl=1;$cl<=$nc;$cl++)
			{
			$v=$tb[$lg][$cl];

			if ($v!=0)
				{
				dessiner_trait($esp,"pixel.gif","");
				echo "<td colspan=\"6\" width=\"$w6\">";
			   echo chr(13);
			   echo chr(10);

		   	echo "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" bordercolor=\"$color\" bordercolordark=\"$color\" bordercolorlight=\"$color\">";
			   echo chr(13);
			   echo chr(10);

				echo "<tr><td class=\"arbre\" width=\"$w6\">";
				$fiche = chercher_individu($v);
						
				if ($fiche)
					{
					$titre="";
					$date=format_date($fiche->datenaissance);
         		if ($date<>"" || $fiche->lieunaissance<>"") $titre="$titre  $date $fiche->lieunaissance ";
         		$date=format_date($fiche->datedeces);
         		
         		if ($date<>"" || $fiche->lieudeces<>"")
         			{
         			if (strlen($titre)>0) $titre="$titre\n";
         			$titre="$titre + $date $fiche->lieudeces ";
         			}
						
   				echo "<a href=\"$url2?lng=$lng&pm=$v.$ng\" title=\"$titre\"> Sosa: $v</a> <br>";
   				$prenom=$fiche->prenom;
   				$pos=strpos($prenom," ");
   				if ($pos<>0) $prenom=substr($prenom,0,$pos);
   				echo "$prenom <br>";
   				echo "$fiche->nom";
   				}

				echo "</td></tr>";
			   echo chr(13);
			   echo chr(10);

				echo "</table>";
			   echo chr(13);
			   echo chr(10);
			   
				echo "</td>";
			   echo chr(13);
			   echo chr(10);
			   
				$cl+=5;
				}
			else $esp++;
			}

		dessiner_trait($esp,"pixel.gif","");
		
		echo "</tr>";
	   echo chr(13);
	   echo chr(13);
	   echo chr(10);

		// Dessin des traits entre deux lignes d'ascendants
		if ($lg<$nl)
			{
			/***************************************
			* tth : tableau de traits hauts
			* ttb : tableau de traits bas
			* sh  : sosa haut
			* sb  : sosa bas
			***************************************/
			// initialisation des tableaux de traits
			for ($cl=1;$cl<=$nc;$cl++) 
				{
				$tth[$cl]=0;
				$ttb[$cl]=0;
				}

			// calcul des tableaux de traits
			for ($cl=1;$cl<=$nc;$cl++)
				{
				$sh=$tb[$lg][$cl];
				$sb=$tb[$lg+1][$cl];			

				// Trait suprieur (pre ou mre)
				$tth[$cl+2]=$sh;
				
				// Trait infrieur (enfant)
				if ($sh==0 || $sh==pere($sb) || $sh==mere($sb)) $ttb[$cl+2]=$sb;
				}

		   // premire ligne de traits verticaux (haut)
		   $esp=0;

			echo "<!-- Traits verticaux -->";
		   echo chr(13);
		   echo chr(10);

			echo "<tr>";
   		echo chr(13);
   		echo chr(10);

			for ($cl=1;$cl<=$nc;$cl++)
				{
				if ($tth[$cl]!=0)
					{
					dessiner_trait($esp, "pixel.gif", "");
	   			echo "<td align=\"right\" valign=\"top\" width=\"$w1\">";
					echo "<img src=\"blue.gif\" border=\"0\" width=\"$epaisseur\" height=\"20\">";
	   			echo "</td>";
	   			echo chr(13);
		   		echo chr(10);
					}
				else $esp++;
				}

			dessiner_trait($esp,"pixel.gif","");
			
			echo "</tr>";
		   echo chr(13);
   		echo chr(13);
   		echo chr(10);

			// ligne de traits horizontaux (intermdiaire)
			$ft=0;
			$esp=0;

			echo "<!-- Traits horizontaux -->";
		   echo chr(13);
		   echo chr(10);

			echo "<tr>";
   		echo chr(13);
   		echo chr(10);

			for ($cl=1;$cl<=$nc;$cl++)
				{
				$sh=$tth[$cl];
				$sb=$ttb[$cl];			

				if ($sh!=0)
					{
					$union=chercher_union($sh);
					$alt="";

		         if ($union)
		            {
		            $date=format_date($union->dateunion);
		            $alt=" x $date $union->lieuunion ";
		            }
											
					if ($ft==0)
						{
						// Dbut de trait
						dessiner_trait($esp,"pixel.gif","");
	   				echo "<td align=\"right\" width=\"$w1\">";
						echo "<img src=\"blue.gif\" alt=\"$alt\" border=\"0\" width=\"$epaisseur\" height=\"$epaisseur\">";
	   				echo "</td>";	   					   				
						}
					else
						{
						// Fin de trait
						dessiner_trait($esp,"blue.gif","$alt");
	   				echo "<td width=\"$w1\">";
						echo "<img src=\"blue.gif\" alt=\"$alt\" border=\"0\" width=\"$w1\" height=\"$epaisseur\">";
	   				echo "</td>";
						}
	
		   		echo chr(13);
   				echo chr(10);

	   			if ($sb==0 || ($sh!=0 && $sh!=pere($sb) && $sh!=mere($sb))) $ft=1-$ft;
					}
				else $esp++;
				}

			dessiner_trait($esp,"pixel.gif","");
			
			echo "</tr>";
   		echo chr(13);
   		echo chr(13);
   		echo chr(10);

			// dernire ligne de traits verticaux (bas)
		   $esp=0;
		   $ft1=0;
		   $ft2=0;

			echo "<!-- Traits verticaux -->";
		   echo chr(13);
		   echo chr(10);
		   
			echo "<tr>";
   		echo chr(13);
   		echo chr(10);

			for ($cl=1;$cl<=$nc;$cl++)
				{
				$sh=$tth[$cl];
				$sb=$ttb[$cl];			

				if ($sh!=0)
					{
	   			if ($sb==0 || ($sh!=pere($sb) && $sh!=mere($sb))) $ft1=1-$ft1;
	   			if ($ft1!=0) $ft2=1;
	   			}
				  														
				if ($sb!=0 && ($ft2!=0 || $sh==pere($sb) || $sh==mere($sb)))
					{
					$ft2=0;
					dessiner_trait($esp,"pixel.gif","");
	   			echo "<td align=\"right\" valign=\"top\" width=\"$w1\">";
					echo "<img src=\"blue.gif\" border=\"0\" width=\"$epaisseur\" height=\"20\">";
	   			echo "</td>";
	   			echo chr(13);
		   		echo chr(10);		   		
					}
				else $esp++;
				}

			dessiner_trait($esp,"pixel.gif","");
			
			echo "</tr>";
   		echo chr(13);
   		echo chr(13);
   		echo chr(10);
			}
		}
?>
</table>

<!-- copyright -->
<?php include ($pub."copyright.php") ?>

</body>
</html>
