<?php
	/*******************************************************************************
	* GENEALOGIE ASCENDANTE EN PHP
	* Construction des fiches individuelles
	* Copyright (c) 2003-2005 Christian BACHELET
	*******************************************************************************/
	
   $root="../";
   $sys=$root."sys/";
   $cfg=$sys."cfg/";
   $photo=$sys."photos/";
   $pub=$root."pub/";
   include ($cfg."cfg.php");
   include ($pub."fonction.php");
   if (isset($lng) == 0) $lng=langue($HTTP_ACCEPT_LANGUAGE);
   include ($cfg.$lng.".php");
   $page="fiche";
   $sSousTitre=$sFiche;      

 	if (isset($pm) == 0) $pm=""; 	
 	$Tab=explode(".",$pm);
	if (count($Tab) > 0) $SosaCourant=$Tab[0];
	if ($SosaCourant=="") $SosaCourant=1;
   $url=$pub."fiche.php";
   $param="&pm=$SosaCourant";			
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<html>
<!-- header de page -->
<?php include ($pub."header.php") ?>

<body>

<!-- affichage du menu -->
<?php include ($pub."menu.php") ?>

<!-- affichage des options -->
<table align="center" border="0" cellpadding="3" cellspacing="0">
   <tr><td><?php echo "$sTexte13" ?></td></tr>
</table>

<br>

<!-- recherche de la fiche individuelle -->
<?php
mysql_connect($sHost,$sUser,$sPass);
mysql_selectdb($sBase);
$SosaCourant=Sosa_Equivalent($SosaCourant);
$SexeIndividu=sexe($SosaCourant);
$fiche=chercher_individu($SosaCourant);
?>

<!-- affichage de la fiche individuelle -->
<table align="center" border="0" cellpadding="3" cellspacing="0">
   <tr>
      <td>
      <?php
      	//la photo         
         if ($fiche->photo<>"")
            {
            $img=$photo.$fiche->photo.".jpg";
            echo "<img src=\"$img\" alt=\"$fiche->prenom $fiche->nom\" border=\"0\" width=\"150\" height=\"200\">";
            }
      ?>
      </td>

      <td>
      <table align="center" border="1" cellpadding="2" cellspacing="0"
         bordercolor="#000000" bordercolordark="#000000" bordercolorlight="#000000">
      <?php
      	//numro sosa
         echo "<tr>";
         echo "<td><b>$sSosa</b></td>";
         echo "<td>$SosaCourant</td>";
         echo "</tr>";

			//l'identit
         echo "<tr>";
         echo "<td><b>$sIdentite</b></td>";
         echo "<td>$fiche->prenom $fiche->nom</td>";
         echo "</tr>";

			//le sexe
         echo "<tr>";
         echo "<td><b>$sSexe</b></td>";
         echo "<td>$SexeIndividu</td>";
         echo "</tr>";

			//le pre
			$SosaPere=pere($SosaCourant);			
			$pere=chercher_individu($SosaPere);

         if ($pere)
            {
            echo "<tr>";
            echo "<td><b>$sPere</b></td>";
            echo "<td><a href=\"$url3?lng=$lng&pm=$SosaPere\"> $pere->prenom $pere->nom</a></td>";
            echo "</tr>";
            }

			//la mre
			$SosaMere=mere($SosaCourant);
			$mere=chercher_individu($SosaMere);

         if ($mere)
            {
            echo "<tr>";
            echo "<td><b>$sMere</b></td>";
            echo "<td><a href=\"$url3?lng=$lng&pm=$SosaMere\"> $mere->prenom $mere->nom</a></td>";
            echo "</tr>";
            }

			//la date et le lieu de naissance
         $date=format_date($fiche->datenaissance);

         if ($date<>"" || $fiche->lieunaissance<>"")
            {
            echo "<tr>";
            echo "<td><b>$sNaissance</b></td>";
            echo "<td>$date $fiche->lieunaissance</td>";
            echo "</tr>";
            }

			//la date et le lieu du dcs
         $date=format_date($fiche->datedeces);

         if ($date<>"" || $fiche->lieudeces<>"")
            {
            echo "<tr>";
            echo "<td><b>$sDeces</b></td>";
            echo "<td>$date $fiche->lieudeces</td>";
            echo "</tr>";
            }

			//la profession
         if ($fiche->profession<>"")
            {
            echo "<tr>";
            echo "<td><b>$sProfession</b></td>";
            echo "<td>$fiche->profession</td>";
            echo "</tr>";
            }

			//le(s) union(s)
			$requete=mysql_query("select sosa1 from $sTbEquivalences where sosa2=$SosaCourant");

   		while ($resultat=mysql_fetch_object($requete))
   			{
				$SosaConjoint=conjoint($resultat->sosa1);
				
				if ($SosaConjoint==sosa_equivalent($SosaConjoint))
					{						
					//le conjoint
					$conjoint=chercher_individu($SosaConjoint);

         		if ($conjoint)
            		{
            		echo "<tr>";
            		echo "<td><b>$sConjoint</b></td>";
            		echo "<td><a href=\"$url3?lng=$lng&pm=$SosaConjoint\"> $conjoint->prenom $conjoint->nom</a></td>";
            		echo "</tr>";
            		}
						   				
   				//date et lieu de l'union			
					$union=chercher_union($SosaConjoint);

         		if ($union)
            		{
            		$date=format_date($union->dateunion);
            		echo "<tr>";
            		echo "<td><b>$sUnion</b></td>";
            		echo "<td>$date $union->lieuunion</td>";
            		echo "</tr>";
            		}
            	}
            }

			//le(s) enfant(s)
			$requete=mysql_query("select sosa1 from $sTbEquivalences where sosa2=$SosaCourant");

   		while ($resultat=mysql_fetch_object($requete))
   			{
				$SosaEnfant=enfant($resultat->sosa1); 
				
				if ($SosaEnfant==sosa_equivalent($SosaEnfant))
					{  				
					$enfant=chercher_individu($SosaEnfant);

         		if ($enfant)
            		{
            		echo "<tr>";
            		echo "<td><b>$sEnfant</b></td>";
            		echo "<td><a href=\"$url3?lng=$lng&pm=$SosaEnfant\"> $enfant->prenom $enfant->nom</a></td>";
            		echo "</tr>";
            		}
            	}
            }
         ?>
      </table>
      </td>
   </tr>
</table>

<!-- copyright -->
<?php include ($pub."copyright.php") ?>

</body>
</html>
